import { Injectable } from '@nestjs/common';
import { BaseDeleteManager } from 'src/core/modules/domain/usecase/managers/base-delete.manager';
import { NewsEntity } from '../../entities/news.entity';
import {
  EventTopics,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { NewsModel } from '../../../data/models/news.model';
import { NewsDeletedEvent } from '../../entities/event/news-deleted.event';

@Injectable()
export class DeleteNewsManager extends BaseDeleteManager<NewsEntity> {
  getResult(): string {
    return `Success`;
  }

  async validateProcess(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return NewsModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: NewsDeletedEvent,
        data: this.data,
      },
    ];
  }
}
